﻿#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
; #Warn  ; Enable warnings to assist with detecting common errors.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.


;===========================
/*
^+!r::
	Reload
	Sleep 1000 ; If successful, the reload will close this instance during the Sleep, so the line below will never be reached.
	MsgBox, 4,, The script could not be reloaded. Would you like to open it for editing?
	IfMsgBox, Yes, Edit
return
*/
;==============================

GetHyphenOrSpacePosition(str)
{
	Hyphen := InStr(str,"-")
	SpaceChar := InStr(str," ")
	
	if(Hyphen != 0 && SpaceChar != 0){
		if(Hyphen < SpaceChar){
			Position := Hyphen
		} else {
			Position := SpaceChar
		}
	} else if (Hyphen == 0 && SpaceChar > 0) {
		Position := SpaceChar
	} else if (SpaceChar == 0 && Hyphen > 0) {
		Position := Hyphen
	} else {
		Position := 0
	}
	
	return Position
}

+^!w::

; Get the process name
WinGet, process, ProcessName, A

if (process = "Dorico.exe"){
;if (true){
	; Sleep time
	SleepTime := 150
	
	; Loaded Text
	FileRead, LoadedText, lyric.txt

	; Original text
	OriginalText := StrReplace(LoadedText,"`r`n"," ")
	
	; Text to process
	TextToProcess := OriginalText
	
	Send +l
	Sleep %SleepTime%
	
	; LOOP START
	While (StrLen(TextToProcess) > 0){
	
		; Find the next hyphen or space
		HyphenOrSpacePosition := GetHyphenOrSpacePosition(TextToProcess)		
		
		if (HyphenOrSpacePosition > 0){
			; Text to write
			TextToWrite := SubStr(TextToProcess,1,HyphenOrSpacePosition)
			; Remaining text
			RemainingText := SubStr(TextToProcess, HyphenOrSpacePosition+1)
		} else {
			TextToWrite := TextToProcess
			RemainingText := ""
		}		
		
		TextToProcess := RemainingText
		
		Send %TextToWrite%
		
		Sleep %SleepTime%
	} ; END LOOP
	
	; Finish with Enter Button
	Send {Enter}
}
return
